app/Http/routes.php
<?php
/**
 * Application Routes
 *
 * Here is where you can register all of the routes for an application.
 * It's a breeze. Simply tell Laravel the URIs it should respond to
 * and give it the controller to call when that URI is requested.
 *
 * PHP version 5.6
 *
 * @category Class
 * @package  Base
 * @author   Michal Hojgr <michal.hojgr@gmail.com>
 * @license  MS Reference
 * @link     http://bookie.gg
 */
/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It's a breeze. Simply tell Laravel the URIs it should respond to
| and give it the controller to call when that URI is requested.
|
*/

Route::get('/mailpreview', ['uses' => 'EmailController@firstclosedbeta']);
Route::get('/help', ['as' => 'help', 'uses' => 'HelpController@show']);

Route::group(
    ['middleware' => 'beta.active_only'],
    function () {
        /**
         * API Methods
         *
         * @see http://docs.bookiegg.apiary.io/
         */
        Route::post(
            '/api/csgo/bank/deposit',
            ['uses' => 'BankController@deposit']
        );

        Route::post(
            '/api/csgo/bank/withdraw',
            ['uses' => 'BankController@withdraw']
        );

        Route::get(
            '/api/profile/tradeurl/verify',
            ['uses' => 'ProfileController@verifyTradeURL']
        );

        Route::post(
            '/api/profile/tradeurl',
            ['uses' => 'ProfileController@storeTradeURL']
        );

        Route::post(
            '/api/core/popup',
            ['uses' => '']
        );

        Route::get(
            '/api/core/popup',
            ['uses' => 'PopupController@getActive']
        );

        Route::get(
            '/',
            ['as' => 'home', 'uses' => 'HomeController@index']
        );
        Route::get(
            '/profile/{id}',
            ['as' => 'profile', 'uses' => 'ProfileController@show']
        );
        Route::get(
            '/article/{id}',
            ['as' => 'article', 'uses' => 'ArticleController@show']
        );
        Route::get(
            '/match/{id}',
            ['as' => 'match', 'uses' => 'MatchController@show']
        );
        Route::get(
            '/bank',
            ['as' => 'bank', 'uses' => 'BankController@show']
        );
        Route::get(
            '/rules',
            ['as' => 'rules', 'uses' => 'SubpageController@rules']
        );
        Route::get(
            '/tos',
            ['as' => 'tos', 'uses' => 'SubpageController@tos']
        );
        Route::get(
            '/contact',
            ['as' => 'contact', 'uses' => 'SubpageController@contact']
        );
        Route::get(
            '/partners',
            ['as' => 'partners', 'uses' => 'SubpageController@partners']
        );

        // TODO: add admin roles
        Route::group(
            [
                'namespace' => 'Admin',
                'prefix' => 'admin',
                'middleware' => 'admin.protect'
            ],
            function () {
                Route::get(
                    '/',
                    ['as' => 'admin_home', 'uses' => 'HomeController@index']
                );

                Route::resource('article', 'ArticleController');
                Route::resource('organization', 'OrganizationController');
                Route::resource('team', 'TeamController');
                Route::resource('match', 'MatchController');

                Route::get(
                    'match/pickwinner/{matchid}/{tid}',
                    [
                        'as' => 'admin.match.pickwinner',
                        'uses' => 'MatchController@pickwinner'
                    ]
                );
                Route::resource('subpage', 'SubpageController');
            }
        );
    }
);


Route::group(
    ['middleware' => 'beta.not_active_only'],
    function () {
        Route::get(
            '/beta',
            ['as' => 'beta_home', 'uses' => 'BetaController@index']
        );
        Route::post(
            '/beta',
            ['as' => 'beta.activate', 'uses' => 'BetaController@activate']
        );
        Route::post(
            '/beta/subscribe',
            ['as' => 'beta.subscribe', 'uses' => 'BetaSubscribeController@index']
        );
    }
);

Route::get('/login', ['as' => 'login', 'uses' => 'SteamController@login']);
Route::get('/auth', ['as' => 'auth', 'uses' => 'SteamController@auth']);
Route::get('/logout', ['as' => 'logout', 'uses' => 'SteamController@logout']);

/**
 * Statically serve images from storage
 */
Route::get(
    'upload_assets/{thing}/{type}/{filename}',
    [
        'as' => 'uploaded_asset',
        'uses' => function ($thing, $type, $filename) {
            if (!in_array($thing, ['logo', 'banner'])) {
                App::abort(403);
            }

            $path = storage_path($thing . "s/" . $type . "s") . "/$filename";

            $response = Response::make(File::get($path));
            $response->header('Content-Type', File::type($path));
            $response->header('Content-Size', File::size($path));

            return $response;
        }
    ]
);

app/Models/Team.php
<?php namespace BookieGG\Models;

use BookieGG\Traits\HasLogo;
use Illuminate\Database\Eloquent\Model;

class Team extends Model {

    use HasLogo;

    public function match() {
        $this->belongsToMany('BookieGG\Models\Match');
    }

}

app/Http/Controllers/Admin/TeamController.php
<?php namespace BookieGG\Http\Controllers\Admin;

use BookieGG\Commands\CreateTeamCommand;
use BookieGG\Commands\EditTeamCommand;
use BookieGG\Contracts\Repositories\TeamRepositoryInterface;
use BookieGG\Http\Requests;
use BookieGG\Http\Controllers\Controller;

use Illuminate\Http\Request;

class TeamController extends Controller {

    /**
     * Display a listing of the resource.
     *
     * @param TeamRepositoryInterface $tri
     * @return Response
     */
    public function index(TeamRepositoryInterface $tri)
    {
        return view('admin/team/index')->with('teams', $tri->getAll())
            ->with('hide_right_side', true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
        return view('admin/team/create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Requests\TeamAddRequest $request
     * @return Response
     */
    public function store(Requests\TeamAddRequest $request)
    {
        $name = \Input::get('name');
        $shortname = \Input::get('shortname');
        $logo = \Input::file('logo');

        $this->dispatch(new CreateTeamCommand(
            $name,
            $shortname,
            $logo
        ));

        \Session::flash('message',
            [['type' => 'success', 'message' => "Team <i>$name</i> was successfully created"]]);

        return \Redirect::route('admin.team.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param TeamRepositoryInterface $tri
     * @param  int $id
     * @return Response
     */
    public function edit(TeamRepositoryInterface $tri, $id)
    {
        return view('admin/team/edit')->with('team', $tri->getById($id));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param Requests\TeamEditRequest $request
     * @param  int $id
     * @return Response
     */
    public function update(Requests\TeamEditRequest $request, $id)
    {
        $name = \Input::get('name');
        $image = \Input::file('logo');

        $this->dispatch(new EditTeamCommand($id, $name, $image));

        \Session::flash('message',
            [['type' => 'success', 'message' => "Team <i>$name</i> was successfully edited"]]);

        return \Redirect::route('admin.team.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return Response
     */
    public function destroy($id)
    {
        //
    }

}

resources/views/admin/team/create.blade.php
@extends('admin/app')

@section('content')
	<div class="content-box">
		<h2>Add team</h2>

		<ul class="validation">
			@foreach($errors->all() as $error)
				<li class="error">{{ $error }}</li>
			@endforeach
		</ul>

		{!! Form::open(['route' => 'admin.team.store', 'files' => 'true']) !!}

		<table class="form-table">
			<tr>
				<td>{!! Form::label('name', 'Team') !!}</td>
				<td>{!! Form::text('name', null, ['placeholder' => 'Teb\'s team', 'class' => 'form-control']) !!}</td>
			</tr>

			<tr>
				<td>{!! Form::label('shortname', 'Short name') !!}</td>
				<td>{!! Form::text('shortname', null, ['placeholder' => 'Leave empty if it\'s the same as name', 'class' => 'form-control']) !!}</td>
			</tr>

			<tr>
				<td>{!! Form::label('logo', 'Logo') !!}</td>
				<td>{!! Form::file('logo') !!}</td>
			</tr>

			<tr>
				<td></td>
				<td>{!! Form::submit('Add new team', ['class' => 'btn btn-primary']) !!}</td>
			</tr>

		</table>


		{!! Form::close() !!}
	</div>
@endsection

resources/views/admin/team/edit.blade.php
@extends('admin/app')

@section('content')
	<div class="content-box">
		<h2>Edit team [{{ $team->name }}]</h2>

		<ul class="validation">
			@foreach($errors->all() as $error)
				<li class="error">{{ $error }}</li>
			@endforeach
		</ul>

		{!! Form::open(['url' => route('admin.team.update', $team->id), 'files' => 'true', 'method' => 'PUT']) !!}

		<table class="form-table">
			<tr>
				<td>{!! Form::label('name', 'Team') !!}</td>
				<td>{!! Form::text('name', $team->name, ['placeholder' => 'Teb\'s team', 'class' => 'form-control']) !!}</td>
			</tr>

			<tr>
				<td>{!! Form::label('shortname', 'Short name') !!}</td>
				<td>{!! Form::text('shortname', $team->short_name, ['placeholder' => 'Leave empty if it\'s the same as name', 'class' => 'form-control']) !!}</td>
			</tr>

			<tr>
				<td>{!! Form::label('logo', 'Logo') !!}</td>
				<td>{!! Form::file('logo') !!}</td>
			</tr>

			<tr>
				<td></td>
				<td>{!! Form::submit('Edit team', ['class' => 'btn btn-primary']) !!}</td>
			</tr>

		</table>


		{!! Form::close() !!}
	</div>
@endsection

resources/views/admin/team/index.blade.php
@extends('admin/app')

@section('content')
	<div class="content-box" style="width: 940px">
		<h2>All teams <a class='btn btn-primary' href="{{ route('admin.team.create') }}">Add</a></h2>
		<br />
		<table class="table table-middle">
			<tr>
				<th>Logo</th>
				<th>Name</th>
				<th></th>
			</tr>
			@foreach($teams as $t)
			<tr>
				<td>{!! LogoUtil::render($t) !!}</td>
				<td>
					{{ $t->name }}
					@if($t->name != $t->short_name)
						({{ $t->short_name }})
					@endif
				</td>
				<td><a class="btn btn-info" href="{{ route('admin.team.edit', $t->id) }}">edit</a></td>
			</tr>
			@endforeach
		</table>

	</div>
@endsection